<?xml version="1.0" encoding="Shift_JIS" ?>
		<!-- ezFileList.xsl -->
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output method="html" version="4.01" encoding="SHIFT_JIS" indent="yes"
	doctype-public="-//W3C//DTD HTML 4.01 Transitional//EN"
	doctype-system="http://www.w3.org/TR/html4/loose.dtd"/>

<xsl:variable name="fileListFN" select="'../ezFileList.xml'"/>
<xsl:variable name="fileList" select="document($fileListFN)/fileList"/>
<xsl:variable name="currentFN" select="'ezFileCurrent.xml'"/>
<xsl:variable name="current" select="document($currentFN)/list"/>

<xsl:template match="/">
	<xsl:apply-templates select="fileList"/>
</xsl:template>

<xsl:template match="fileList">
	<html>
	<head>
		<meta http-equiv="Content-Style-Type" content="text/css"/>
		<title>
			<xsl:call-template name="setTitle"/>
		</title>
	</head>
	<body>
		<xsl:call-template name="heading"/>
		<hr/>
		<xsl:call-template name="bodyProc"/>
		<hr/>
		<xsl:text>[eod]</xsl:text>
	</body>
	</html>
</xsl:template>

<xsl:template name="setTitle">
	<xsl:variable name="str">
		<xsl:value-of select="normalize-space(title)"/>
	</xsl:variable>
	<xsl:choose>
	<xsl:when test="string-length($str) > 0">
		<xsl:value-of select="title"/>
	</xsl:when>
	<xsl:otherwise>
		<xsl:value-of select="'t@Cꗗ'"/>
	</xsl:otherwise>
	</xsl:choose>
</xsl:template>

<xsl:template name="heading">
	<center>
		<h2>
			<xsl:call-template name="setTitle"/>
		</h2>
		<xsl:apply-templates select="subtitle"/>
	</center>
</xsl:template>

<xsl:template name="bodyProc">
	<h3>PDꗗ\̃t@C</h3>
	<blockquote>
		<xsl:text>
			t@Cꗗ\"ezFileList.xml"ɋLڂꂽt@Ć̖A
			Aт̃t@C̑ݏ󋵂܂B
		</xsl:text>
		<table>
			<tr-nc><th align="right">#
				</th><th width="50">
					</th><th>t@C
						</th><th>
							<xsl:text>@</xsl:text>
							</th><th>
								</th></tr-nc>
			<xsl:apply-templates select="group | item"/>
		</table>
		<xsl:text>
			ij݁F e ́A݂AD ݂͑Ȃt@C
		</xsl:text>
	</blockquote>
	<xsl:call-template name="addedFile"/>
</xsl:template>

<xsl:template match="group">
	<xsl:variable name="number">
		<xsl:number count="group" from="fileList" level="multiple"/>
	</xsl:variable>
	<tr><td colspan="4" style="font-weight: bold">
		<xsl:value-of select="$number"/>
		<xsl:text>. </xsl:text>
		<xsl:value-of select="@title"/>
						</td></tr>
	<xsl:apply-templates select="group | item"/>
</xsl:template>

<xsl:template match="item">
	<xsl:variable name="file" select="normalize-space(file)"/>
	<tr valign="top"><td align="right">
	<xsl:number count="item" from="fileList" level="any"/>
	<xsl:text>)</xsl:text>
		</td><td align="center">
			<xsl:call-template name="fileExist">
				<xsl:with-param name="file" select="$file"/>
			</xsl:call-template>
			</td><td>
			<a>
				<xsl:attribute name="href">
					<xsl:value-of select="$file"/>
				</xsl:attribute>
				<xsl:value-of select="$file"/>
			</a>
				</td><td>
					<xsl:text>@</xsl:text>
					</td><td>
					<xsl:value-of select="note"/>
						</td></tr>
</xsl:template>

<xsl:template name="fileExist">
	<xsl:param name="file" select="''"/>
	<xsl:variable name="flag">
		<xsl:apply-templates select="$current/file[text() = $file]" 
		mode="chkcurrent"/>
	</xsl:variable>
	<xsl:choose>
	<xsl:when test="$flag = 'yes'">
		<xsl:text>e</xsl:text>
	</xsl:when>
	<xsl:otherwise>
		<xsl:text>D</xsl:text>
	</xsl:otherwise>
	</xsl:choose>
</xsl:template>

<xsl:template match="file" mode="chkcurrent">
	<xsl:text>yes</xsl:text>
</xsl:template>

<xsl:template name="addedFile">
	<h3>QDǉꂽt@C</h3>
	<blockquote>
		<xsl:text>
			O͂̈ꗗ\ɂȂČt@C΂Ɏ܂B
		</xsl:text>
		<blockquote>
		<table>
		<tr><th align="left">t@C
			</th></tr>
			<xsl:apply-templates select="$current/file" mode="chkAdded"/>
		</table>
		</blockquote>
	</blockquote>
</xsl:template>

<xsl:template match="file" mode="chkAdded">
	<xsl:variable name="file" select="."/>
	<xsl:variable name="flag">
		<xsl:apply-templates select="$fileList/group | $fileList/item" 
			mode="chkAdded">
			<xsl:with-param name="file" select="$file"/>
		</xsl:apply-templates>
	</xsl:variable>
	<xsl:if test="not (starts-with($flag, 'exist'))">
		<xsl:call-template name="fileProc"/>
	</xsl:if>
</xsl:template>

<xsl:template match="group" mode="chkAdded">
	<xsl:param name="file" select="."/>
	<xsl:apply-templates select="group | item" mode="chkAdded">
		<xsl:with-param name="file" select="$file"/>
	</xsl:apply-templates>
</xsl:template>

<xsl:template match="item" mode="chkAdded">
	<xsl:param name="file" select="."/>
	<xsl:if test="normalize-space(file) = $file">
		<xsl:text>exist</xsl:text>
	</xsl:if>
</xsl:template>

<xsl:template name="fileProc">
	<tr><td>
	<xsl:value-of select="."/>
		</td></tr>
</xsl:template>

</xsl:stylesheet>
